<?php
function getCharacterSize($font, $text, $size, $angle)
{
	$bbox = imagettfbbox($size, 0, $font, $text);
	$angle = $angle/ 180 * pi();
	for ($i=0; $i<4; $i++)
	{
		$x = $bbox[$i * 2];
		$y = $bbox[$i * 2 + 1];
		$bbox[$i * 2] = cos($angle) * $x - sin($angle) * $y;  // X
		$bbox[$i * 2 + 1] = sin($angle) * $x + cos($angle) * $y; // Y
	}
	$bbox["left"] = 0- min($bbox[0],$bbox[2],$bbox[4],$bbox[6]);
	$bbox["top"] = 0- min($bbox[1],$bbox[3],$bbox[5],$bbox[7]);
	$bbox["width"] = max($bbox[0],$bbox[2],$bbox[4],$bbox[6]) -  min($bbox[0],$bbox[2],$bbox[4],$bbox[6]);
	$bbox["height"] = max($bbox[1],$bbox[3],$bbox[5],$bbox[7]) - min($bbox[1],$bbox[3],$bbox[5],$bbox[7]);
	return $bbox;
}

function fixbbox($bbox)
{
  $tmp_bbox["left"] = min($bbox[0],$bbox[2],$bbox[4],$bbox[6]);
  $tmp_bbox["top"] = min($bbox[1],$bbox[3],$bbox[5],$bbox[7]);
  $tmp_bbox["width"] = max($bbox[0],$bbox[2],$bbox[4],$bbox[6]) -
   min($bbox[0],$bbox[2],$bbox[4],$bbox[6]) + 1;
  $tmp_bbox["height"] = max($bbox[1],$bbox[3],$bbox[5],$bbox[7]) - min($bbox[1],$bbox[3],$bbox[5],$bbox[7]);

  $tmp_bbox["left"] = 0 - $tmp_bbox["left"];
  $tmp_bbox["top"] = 0 - $tmp_bbox["top"];
  return $tmp_bbox;
}

$size=$_GET['size']; if($size=='') $size=12;
$color=$_GET['color']; if($color=='') $color='ffffff';
$bcolor=$_GET['bg']; if($bcolor=='') $bcolor='00000';
$font=$_GET['font']; if($font=='') $font='gentium';
$font=realpath('font/'.$font.'.ttf');
$text=$_GET['text'];
$text=str_replace('^', '&#', $text);
if($text==''||$text=='&#32;') $text=' ';
$height=$_GET['bh'];

$acc=fixbbox(imagettfbbox($size, 0, $font, ''));
$nacc=fixbbox(imagettfbbox($size, 0, $font, 'a'));
$accheight=$acc['height']-$nacc['height'];

$box=getCharacterSize($font, $text, $size, 0);
$width=$box['width'];
$box=getCharacterSize($font, str_repeat($text, 10), $size, 0);
$width=$box['width']/10;

$fullheight=$height+$accheight+$_GET['down'];


header ("Content-type: image/png");
$im = @imagecreatetruecolor($width, $fullheight) or die("Cannot initialize new GD image stream");
$r=hexdec(substr($color,0,2));
$g=hexdec(substr($color,2,2));
$b=hexdec(substr($color,4,2));
$lettercolor=imagecolorallocate($im, $r, $g, $b);
$r=hexdec(substr($bcolor,0,2));
$g=hexdec(substr($bcolor,2,2));
$b=hexdec(substr($bcolor,4,2));

$backcolor=imagecolorallocate($im, $r, $g, $b);
imagefilledrectangle($im, 0, 0, $width, $fullheight, $backcolor);
imagettftext($im, $size, 0, 0, $size+$accheight+$_GET['down']-$_GET['up'], $lettercolor, $font, $text);

imagepng($im);
imagedestroy($im);
?>
