<?php
/*
Plugin Name: GraphText
Plugin URI: http://lattilad.org
Description: Creating text images from BBCode
Author: LAttilaD
Version: 1.0
Author URI: http://lattilad.org
*/

add_filter('init', 'plugin_graphtext_init');

function plugin_graphtext_init() {
	global $graphtext;
	$graphtext=array(
		'font'=>'hunglingtesz',
		'size'=>24,
		'ink'=>'ffffff',
		'paper'=>'000000',
		'height'=>40,
		'down'=>0,
		'up'=>0,
    );

	$bbcode =& plugin_bbcode_init();

	$bbcode->addCode (
	  'gt',
	  'callback_replace',
	  'plugin_graphtext_gt',
	  array('usecontent_param' => array ('default')),
	  'inline',
	  array ('listitem', 'block', 'inline', 'link'),
	  array ());
	$bbcode->setCodeFlag ('gt', 'closetag', BBCODE_CLOSETAG_MUSTEXIST);

}

function plugin_graphtext_gt($action, $attributes, $content, $params, &$node_object) {
	if ($action == 'validate') {
		return true;
	}

	global $graphtext;

	foreach($graphtext as $key=>$value)
    	if($attributes[$key]!='')
        	$graphtext[$key]=$attributes[$key];

	$uri='http://'.$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).'/'.PLUGINS_DIR.'graphtext/graphtext.php?'.
		'font='.$graphtext['font'].
		'&size='.$graphtext['size'].
		'&color='.$graphtext['ink'].
		'&bg='.$graphtext['paper'].
		'&up='.$graphtext['up'].
		'&down='.$graphtext['down'].
		'&bh='.$graphtext['height'];

	$text=str_replace(chr(13), '&#13;', $content);
	$text=str_replace('^', '&#94;', $text);
	$text=str_replace('&#', '^', $text);
	$uri.='&text='.$text;

	return '<img src="'.$uri.'" valign=bottom>';
}
?>
